;***************************************************
;* Mutiply 24x8 -> 32 bit
;*       AH  AM  AL   BL     E3 E2 E1 E0
;*      R22:R21:R20 x R16 -> R5:R4:R3:R2
;*
;*  19 cycles + 4 (RET) = 23 Cycles
;*
muls24x8_32:
		push	R10
		clr		R10
		mulsu	R16,R20			; AL x BL -> BL x AL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		muls	R22,R16			; AH x BL
		movw	R5:R4,R1:R0		; r1:r0 -> E3:E2
		mul		R21,R16			; AM x BL
		add		R3,R0			; R0 -> E1
		adc		R4,R1			; R1 -> E2
		adc		R5,R10			; T0 -> E3
		pop		R10  
		ret