.macro mul_
        ;---------------------------------
        ;mul Befehl in Software als Makro
        ;---------------------------------
        clr     r1      ;Ergebnis = 0
        push    @0      ;Multiplikant wegspeichern
        sec             ;Multiplikant ersetzt gleichzeitig den Schleifenzähler
        ror     @0      ;Eine 1 rein, LSB raus
        rjmp    mul2    ;Beim 1. Durchgang, gleich LSB auswerten
mul1:   lsr     @0      ;Bit (von 1..7 Niederwertige zuerst) ins Carry (Multiplikand)
        breq    mul4    ;Wenn die 1 von sec (oben) wieder im Carry ist, Ende
mul2:   brcc    mul3    ;Wenn 0, Addition überspringen
        add     r1,@1   ;Ansonsten Multiplikator ins Highbyte addieren
mul3:   ror     r1      ;Produkt mit evt. Übertrag nach rechts schieben
        ror     r0
        rjmp    mul1    ;Noch ne Runde (von insgesamt 8)
mul4:   push	r16
		in		r16,SREG
		andi	r16,0x80
		out		SREG,r16
		sbrc	r1,7
		sec
		pop		r16
		pop     @0      ;Multiplikant zurückholen
.endm



.macro	muls_
		push	r16
		push	r17
		push	r18
		clt
		mov		r1,@0
		mov		r0,@1
		clr		r17  
		sbrc	r1,7
		inc		r17
		sbrc	r0,7
		inc		r17
		sbrc	r17,0
		set
		mov		r16,r1
		rcall	_muls_
		andi	r17,0x82
		sbrc	r17,SREG_Z	
		rjmp	PC+3
		brtc	PC+2
		sbr		r17,(1<<SREG_C)
		out		SREG,r17
		pop		r18
		pop		r17
		pop		r16
.endm


_muls_:	sub		r1,r1			; clear result High byte and carry
		ldi		r18,8			; init loop counter
_m8s_1:	brcc	_m8s_2			; if carry (previous bit) set
		add		r1,r16			; add multiplicand to result High byte
_m8s_2:	sbrc	r0,0			; if current bit set
		sub		r1,r16			; subtract multiplicand from result High
		asr		r1				; shift right result High byte
		ror		r0				; shift right result L byte and multiplier
		in		r17,SREG
		dec		r18				; decrement loop counter
		brne	_m8s_1			; if not done, loop more
		ret

.macro	mulsu_
		push	r16
		push	r17
		push	r18
		mov		r1,@0
		mov		r0,@1
		mov		r16,r1
		clt
		sbrc	r16,7
		set
		sbrc	r16,7
		neg		r16
		rcall	_mulsu_
		andi	r17,0x83
		brtc	PC+6
		com		r1
		com		r0
		ldi		r16,1	
		add		r0,r16
		adc		r1,r18
		sbrc	r1,7   
		sbr		r17,(1<<SREG_C)
		out		SREG,r17	
		pop		r18
		pop		r17
		pop		r16
.endm

_mulsu_:clr		r1			;clear result High byte
		ldi		r18,8		;init loop counter
		lsr		r0			;rotate multiplier	
m8su_1:	brcc	m8su_2		; carry set 
		add 	r1,r16		; add multiplicand to result High byte
m8su_2:	ror		r1			; rotate right result High byte
		ror		r0			; rotate right result L byte and multiplier
		in		r17,SREG
		dec		r18			; decrement loop counter
		brne	m8su_1		; if not done, loop more
		ret
